/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description: 
*
*/

#ifndef CMDNSCACHECONSISTENCYMGR_H_
#define CMDNSCACHECONSISTENCYMGR_H_

#include <e32base.h>
#include <mdns/mdnscachemgr.h>


class CMDNSCacheConsistencyMgr : public CActive
	{
	public:
	
	IMPORT_C static CMDNSCacheConsistencyMgr* NewL(TBool aActiveCacheMgmtEnabled,MDNSCacheMgr& aCache);
	static CMDNSCacheConsistencyMgr* NewLC(TBool aActiveCacheMgmtEnabled,MDNSCacheMgr& aCache);
	
	IMPORT_C void Start();
		
	~CMDNSCacheConsistencyMgr();
	void DoCancel();
	
	private:
					
	void RunL();
	TInt RunError(TInt aError);
	
			
	private:
	
	CMDNSCacheConsistencyMgr(TBool aActiveCacheMgmtEnabled,MDNSCacheMgr& aCache);
	void ConstructL();

	private:
	
	MDNSCacheMgr& iCache;
	
	TBool iActiveCacheMgmtEnabled;	
	
	TUint iWalkInterval;
	
	RTimer iTimer;
	};


#endif /*CMDNSCACHECONSISTENCYMGR_H_*/
